// BeOS mutex

#ifndef _be_condvar_h
#define _be_condvar_h 1

#include <kernel/OS.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct be_mutex_t
{
	int32			init;
	sem_id			lock;
	thread_id		owner;
} be_mutex_t;

#define	BE_MUTEX_INITIALIZER { 2000, -1, -1 }

// attributes are currently unused
typedef int32 be_mutexattr_t;

// mutex operations
status_t be_mutex_init(be_mutex_t* mutex, be_mutexattr_t* attr);
status_t be_mutex_destroy(be_mutex_t* mutex);
status_t be_mutex_lock(be_mutex_t* mutex);
status_t be_mutex_unlock(be_mutex_t* mutex);


#ifdef __cplusplus
}
#endif

#endif
